import java.io.*;
import java.nio.file.*;
import java.nio.file.attribute.*;

public class FileVisit {
    public static void main(String... args) throws IOException {
        if (args.length <= 0) {
            System.out.println("R}hCŃfBNgw肵Ă");
            System.exit(0);
        }

        Path path = Paths.get(args[0]);
        Files.walkFileTree(path, new SimpleFileVisitor<Path>() {
            @Override
            public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) throws IOException {
                System.out.println(file);
                if (attrs.isDirectory() && !Files.isReadable(file)) {
                    return FileVisitResult.SKIP_SUBTREE;
                } else {
                    return FileVisitResult.CONTINUE;
                }
            }
        });
    }
}
