import java.util.concurrent.*;

public class Main {
    private static class Worker {
        public String exec() {
            emulateLongTask();
            return "RESULT";
        }
        public Integer aggregate(String input) {
            return input.length();
        }
        public void showResult(Integer result, Throwable error) {
            if (error != null) {
                System.out.println("error");
                return;
            }
            System.out.println("ret=" + result);
        }
        private void emulateLongTask() { // lbg[NANZXȂǏdz
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {}
        }
    }

    public static void main(String... args) throws InterruptedException, ExecutionException {
        Worker worker = new Worker();
        CompletableFuture<Integer> future = CompletableFuture.supplyAsync(worker::exec)
            .thenComposeAsync(s -> CompletableFuture.supplyAsync(worker::exec))
            .thenApplyAsync(worker::aggregate)      //=> worker::exec̎s"RESULT"͂Ƃworker::aggregateĂяo
            .whenCompleteAsync(worker::showResult); //=> "RESULT"̕񒷂6\
        future.join();  // Lthen̏Iő҂
    }
}
