import java.util.*;
import java.io.*;
import java.net.*;
import java.util.concurrent.*;

public class MyConcurrentServer {
    private static final int LISTEN_PORT = 9000; // ҂󂯃|[gԍiNCAgƎO茈߁j
    private static final char END_MARK = '.'; // I[iNCAgƂ̎O茈߁j
    private final ExecutorService executor;

    public MyConcurrentServer() {
        this.executor = Executors.newFixedThreadPool(8);
    }

    private static class Worker implements Runnable {
        private final Socket sock;

        Worker(Socket sock) {
            this.sock = sock;
        }

        @Override
        public void run() { // NCAgƂ̒ʐMi1̃NCAgƂ1̃XbhΉj
            try (Socket sock = this.sock;  // closetry-with-resourcesɔC邽߂̋ZI
                 Reader in = new BufferedReader(new InputStreamReader(sock.getInputStream()));
                 Writer out = new BufferedWriter(new OutputStreamWriter(sock.getOutputStream()))) {
                StringBuilder sb = new StringBuilder(4096);

                int c;
                while ((c = in.read()) != -1) {
                    System.out.print(new Character((char)c));
                    if (c == END_MARK) {
                        break;
                    }
                    sb.append((char)c);
                }
                out.write(sb.toString());
                out.flush();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public void runLoop() {
        try (ServerSocket ssock = new ServerSocket(LISTEN_PORT)) { // ҂󂯃\Pbgi󓮓I\Pbgj
            while (true) {
                Socket sock = ssock.accept(); // NCAg̐ڑ҂
                executor.execute(new Worker(sock)); // 󂯓\PbgWorkerɓnăXbhiXbhv[擾j
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            executor.shutdown();
        }
    }

    public static void main(String... args) {
        MyConcurrentServer server = new MyConcurrentServer();
        server.runLoop();
    }
}
