import java.util.*;
import java.util.concurrent.*;
import java.io.*;

public class MyProduceConsume {
    private static class Producer implements Runnable {
        private final Queue<String> queue;

        Producer(Queue<String> queue) {
            this.queue = queue;
        }

        @Override
        public void run() { // ʒmXbh̃Gg|Cg
            Console console = System.console();
            while (true) {
                System.out.println("input any string");
                String s = console.readLine();
                synchronized(queue) {
                    queue.add(s);  // ҋ@𔲂𐬗
                    queue.notifyAll(); // ҋ@XbhN
                }
            }
        }
    }

    private static class Consumer implements Runnable {
        private final Queue<String> queue;

        Consumer(Queue<String> queue) {
            this.queue = queue;
        }

        @Override
        public void run() { // ҋ@Xbh̃Gg|Cg
            try {
                while (true) {
                    synchronized(queue) {
                        while (queue.isEmpty()) { // ҋ@𔲂
                            System.out.println("waiting...");
                            queue.wait();         // őҋ@
                        }
                        String s = queue.remove();
                        System.out.println(s + " is consumed");
                    }
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    public static void main(String... args) throws InterruptedException, ExecutionException {
        Queue<String> queue = new LinkedList<>(); // Lf[^ʒmIuWFNg

        ExecutorService executor = Executors.newFixedThreadPool(8);

        Future<?> producer = executor.submit(new Producer(queue));
        Future<?> consumer = executor.submit(new Consumer(queue));

        // Futureget\bhŃTuXbhҋ@
        producer.get();
        consumer.get();
        executor.shutdown();
    }
}
