import java.util.*;
import java.io.*;
import java.lang.reflect.*;

public class MyEcho3 {
    private static class Filter {
        Filter(Object obj, Method method) {
            this.obj = obj;
            this.method = method;
        }
        final Object obj;
        final Method method;
    }

    private final List<Filter> filters = new ArrayList<>();

    public MyEcho3(String... classNames) throws ReflectiveOperationException {
        // vOCR[h̃[h
        for (String className : classNames) {
            Class clazz = Class.forName(className); // tNVŒT
            for (Method method : clazz.getMethods()) {
                MyFilter myfilter = method.getAnnotation(MyFilter.class); // Ame[V̓ǂݎ
                if (myfilter != null) {
                    switch (myfilter.value()) {
                    case BEFORE:
                        filters.add(0, new Filter(clazz.newInstance(), method));
                        break;
                    case AFTER:
                        filters.add(new Filter(clazz.newInstance(), method));
                        break;
                    }
                }
            }
        }
    }

    public void exec() {
        try (BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in))) {
            while (true) {
                System.out.println("Input any text");
                String msg = stdin.readLine();

                String output = msg;
                for (Filter filter : filters) {
                    output = (String)filter.method.invoke(filter.obj, output);
                }
                System.out.println("You said, " + output);
            }
        } catch (IOException | ReflectiveOperationException e) {
            e.printStackTrace();
        }
    }

    public static void main(String... args) throws ReflectiveOperationException {
        MyEcho3 echo = new MyEcho3(args); // R}hCŃNXw
        echo.exec();
    }
}
