import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Line;
import javafx.scene.shape.Polygon;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.stage.Stage;

public class MyApplication extends Application {
    @Override
    public void start(Stage primaryStage) throws Exception {
        Rectangle rectangle = new Rectangle(30, 130, 180, 45);
        rectangle.setFill(Color.DARKGRAY);
        
        double lineStrokeWidth = 2;
        Line line1 = new Line(0, 0, 50, 100);
        line1.setStrokeWidth(lineStrokeWidth);
        Line line2 = new Line(0, 10, 50, 110);
        line2.setStrokeWidth(lineStrokeWidth);
        Line line3 = new Line(0, 20, 50, 120);
        line3.setStrokeWidth(lineStrokeWidth);
        
        Polygon triangle = new Polygon(10,210, 110,10, 210,10);
        
        Circle circle = new Circle(55, 70, 15);
        
        Text text = new Text(90, 160, "Graphics");
        text.setFont(Font.font("Courier", 24));
        
        Group root = new Group();
        root.getChildren().addAll(rectangle, line1, line2, line3, triangle,
                circle, text);
        
        Scene scene = new Scene(root);
        primaryStage.setScene(scene);
        
        primaryStage.setTitle("JavaFX Graphics");
        primaryStage.show();
    }
}
