import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.stage.Stage;

public class MyApplication extends Application {
    @Override
    public void start(Stage primaryStage) throws Exception {
        Canvas canvas = new Canvas(210, 210);
        GraphicsContext gc = canvas.getGraphicsContext2D();
        
        gc.save();
        
        gc.setFill(Color.DARKGRAY);
        gc.fillRect(30, 130, 180, 45);
        gc.restore();
        
        gc.setLineWidth(2);
        gc.strokeLine(0, 0, 50, 100);
        gc.strokeLine(0, 10, 50, 110);
        gc.strokeLine(0, 20, 50, 120);
        gc.restore();
        
        gc.fillPolygon(new double[] { 10, 110, 210 },
                new double[] { 210, 10, 10}, 3);
        
        gc.fillOval(40, 55, 30, 30);
        
        gc.setFont(Font.font("Courier", 24));
        gc.fillText("Graphics", 90, 160);
        gc.restore();
        
        Group root = new Group();
        root.getChildren().add(canvas);
        
        Scene scene = new Scene(root);
        primaryStage.setScene(scene);
        
        primaryStage.setTitle("JavaFX Graphics");
        primaryStage.show();       
    }
}
