import javafx.application.Application;
import javafx.geometry.Bounds;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.transform.Rotate;
import javafx.scene.transform.Translate;
import javafx.stage.Stage;

public class MyApplication extends Application {
    @Override
    public void start(Stage stage) throws Exception {
        Image image = new Image(getClass().getResource("duke.jpg").toExternalForm());
        ImageView node = new ImageView(image);

        Bounds bounds = node.getBoundsInLocal();
        double x1 = bounds.getMinX() + bounds.getWidth() / 2;
        double y1 = bounds.getMinY() + bounds.getHeight() / 2;
        
        node.getTransforms().addAll(
                new Translate(x1, y1), new Rotate(45), new Translate(-x1, -y1));

        Group root = new Group();
        root.getChildren().add(node);
        Scene scene = new Scene(root);
        stage.setScene(scene);
        stage.show();
    }
}

