import javafx.beans.binding.IntegerBinding;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

public class Main {
    public static void main(String...args) {
        StringProperty text = new SimpleStringProperty("");
        IntegerProperty count = new SimpleIntegerProperty(0);
        
        count.bind(new IntegerBinding() {
            {
                bind(text);
            }    
            @Override
            protected int computeValue() {
                if (text.get() == null) {
                    return 0;
                }
                return text.get().length();
            }
        });
        
        text.set("word");
        assert(count.get() == 4);
        
        text.set("word word");
        assert(count.get() == 9);
    }
}
