import javafx.beans.property.DoubleProperty;
import javafx.beans.property.SimpleDoubleProperty;
import javafx.scene.control.Control;
import javafx.scene.control.Skin;

public class Knob extends Control {
    public double getMinValue() {
        return 0;
    }

    public double getMaxValue() {
        return 100;
    }

    private DoubleProperty value;
    public DoubleProperty valueProperty() {
        if (value == null) value = new SimpleDoubleProperty(this, "value", 0);
        return value;
    }
    public void setValue(double value) {
        valueProperty().set(value);
    }
    public double getValue() {
        return value == null ? 0 : value.get();
    }

    private DoubleProperty bodyRadius;
    public DoubleProperty bodyRadiusProperty() {
        if (bodyRadius == null) {
            bodyRadius = new SimpleDoubleProperty(this, "bodyRadius", 30);
        }
        return bodyRadius;
    }
    public void setBodyRadius(double value) {
        bodyRadiusProperty().set(value);
    }
    public double getBodyRadius() {
        return bodyRadius == null ? 30 : bodyRadius.get();
    }

    public Knob() {
    }

    public Knob(double value) {
        setValue(value);
    }

    @Override
    protected Skin<Knob> createDefaultSkin() {
        return new KnobSkin(this);
    }
}
