import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.effect.DropShadow;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

public class MyApplication extends Application {
    @Override
    public void start(Stage primaryStage) throws Exception {
        class MyRectangle extends Rectangle {
            MyRectangle(double w, double h) {
                super(w, h);
                setStrokeWidth(1);
                setStroke(Color.BLACK);
                setFill(Color.WHITE);
                setEffect(new DropShadow(1, 4, 4, Color.GRAY));
            }
        }

        Rectangle r1 = new MyRectangle(100, 100);
        Rectangle r2 = new MyRectangle(100, 100);

        double x = 50;
        double y = 25;
        r1.relocate(x, y);

        x += r1.getLayoutBounds().getWidth();
        y += 50;
        r2.relocate(x, y);

        Group root = new Group();
        root.getChildren().addAll(r1, r2);

        Scene scene = new Scene(root, 300, 200);
        primaryStage.setTitle("Positioning");
        primaryStage.setScene(scene);
        primaryStage.show();
    }
}
