import java.util.Optional;

class Name {
    private final Optional<String> first;
    private final Optional<String> last;
    Name(String first, String last) {
        this.first = Optional.ofNullable(first);
        this.last = Optional.ofNullable(last);
    }
    Optional<String> getFirst() {
        return this.first;
    }
}

class Person {
    private final Optional<Name> name;
    Person(Name name) {
        this.name = Optional.ofNullable(name);
    }
    Optional<Name> getName() {
        return this.name;
    }
}

public class Main {
    // Xg4.4̏iu_ƃXg[v̏͂Ő郁\bhQƂgĂ܂j
    void showPersonFirstName(Optional<Person> person) {
        person.flatMap(Person::getName)   // getName\bhĂяoAʂOptional^ŕԂ
            .flatMap(Name::getFirst)    // getFirst\bhĂяoAʂOptional^ŕԂ
            .ifPresent(System.out::println);   // OptionalłȂprintlnĂ
    }

    public static void main(String... args) {
        Main main = new Main();
        Person person = new Person(new Name("Bill", "Joy"));
        main.showPersonFirstName(Optional.of(person));
    }
}
