import java.util.*;
import java.io.*;

public class MyEcho2 {
    private final List<MyFilter> filters;

    public MyEcho2(List<MyFilter> filters) {
        this.filters = filters;
    }

    public void exec() {
        try (BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in))) {
            while (true) {
                System.out.println("Input any text");
                String msg = stdin.readLine();

                String output = msg;
                for (MyFilter filter : filters) {
                    output = filter.doJob(output);
                }
                System.out.println("You said, " + output);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
